"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var config_1 = __importDefault(require("../../server/config"));
var workspaces_1 = require("../../server/workspaces");
var provider_1 = require("./provider");
var util_1 = require("../../common/util");
var patterns_1 = require("../../common/patterns");
function provider(line, uri, position) {
    if (util_1.isSomeMatchPattern(patterns_1.notIdentifierPattern, line)) {
        return [];
    }
    else if (/\b[gbsla]:\w*$/.test(line)) {
        var list = [];
        if (/\bg:\w*$/.test(line)) {
            list = workspaces_1.workspace.getIdentifierItems(uri, position.line)
                .filter(function (item) { return /^g:/.test(item.label); });
        }
        else if (/\bb:\w*$/.test(line)) {
            list = workspaces_1.workspace.getIdentifierItems(uri, position.line)
                .filter(function (item) { return /^b:/.test(item.label); });
        }
        else if (/\bs:\w*$/.test(line)) {
            list = workspaces_1.workspace.getIdentifierItems(uri, position.line)
                .filter(function (item) { return /^s:/.test(item.label); });
        }
        else if (/\bl:\w*$/.test(line)) {
            list = workspaces_1.workspace.getIdentifierItems(uri, position.line)
                .filter(function (item) { return /^l:/.test(item.label); });
        }
        else if (/\ba:\w*$/.test(line)) {
            list = workspaces_1.workspace.getIdentifierItems(uri, position.line)
                .filter(function (item) { return /^a:/.test(item.label); });
        }
        return list.map(function (item) { return (__assign({}, item, { insertText: !/:/.test(config_1.default.iskeyword) ? item.insertText.slice(2) : item.insertText })); });
    }
    else if (/\B:\w*$/.test(line)) {
        return workspaces_1.workspace.getIdentifierItems(uri, position.line)
            .filter(function (item) { return /:/.test(item.label); })
            .map(function (item) {
            var m = line.match(/:[^:]*$/);
            return __assign({}, item, { 
                // delete the `:` symbol
                textEdit: {
                    range: {
                        start: {
                            line: position.line,
                            character: line.length - m[0].length
                        },
                        end: {
                            line: position.line,
                            character: line.length - m[0].length + 1
                        }
                    },
                    newText: item.insertText
                } });
        });
    }
    return workspaces_1.workspace.getIdentifierItems(uri, position.line);
}
provider_1.useProvider(provider);
//# sourceMappingURL=identifier.js.map